program checkoutput
  use dal
  use errorhandling

  implicit none

  type(DataSetT)                  :: inDataSet
  type(TableT)                    :: inTable
  type(ColumnT)                   :: inColumn
  integer                         :: i,nFrames
  logical ok
  real(kind=Double)               :: tStart, tStop, tDel
  real, pointer                   :: rate(:)
 
  
  inDataSet = dataSet("FITS_TRACKING_STAR_TIMESERIES_PPS.FIT", read)
  inTable = table(inDataSet,"RATES") 
  nFrames = numberofRows(inTable)
 
  tStart = real64attribute(inTable, "TSTART")
  tStop = real64attribute(inTable, "TSTOP")
  tDel = real64attribute(inTable, "TIMEDEL")

  if (tStart .lt. 0) then
     call error("neg values","Negative value found in attribute TSTART")
  endif

  if (tStop .lt. 0) then
     call error("neg values","Negative value found in attribute TSTOP")
  endif
  
  if (tDel .lt. 0) then
     call error("neg values","Negative value found in attribute TDEL")
  endif

  
  inColumn = column(inTable, "RATE1", Read)
  rate => real32data(inColumn)
  
  ok = .false.
  
  do i = 0, nFrames-1
     if (rate(i) .lt. 0) then
        ok = .true. 
        write(*,*) i, nFrames
        EXIT
     endif
  enddo
  
  if (ok) then
     
     call error("neg values","Negative value found in column RATE1")
     
  endif
  
  call release(inColumn)  

  inColumn = column(inTable, "RATE2", Read)
  rate => real32data(inColumn)
  
  ok = .false.
  
  do i = 0, nFrames-1
     if (rate(i) .lt. 0) then
        ok = .true. 
        write(*,*) i, nFrames
        EXIT
     endif
  enddo
  
  if (ok) then
     
     call error("neg values","Negative value found in column RATE2")
     
  endif
  
  call release(inColumn)  

  inColumn = column(inTable, "RATE2", Read)
  rate => real32data(inColumn)
  
  ok = .false.
  
  do i = 0, nFrames-1
     if (rate(i) .lt. 0) then
        ok = .true. 
        write(*,*) i, nFrames
        EXIT
     endif
  enddo
  
  if (ok) then
     
     call error("neg values","Negative value found in column RATE2")
     
  endif
  
  call release(inColumn)  

  inColumn = column(inTable, "RATE3", Read)
  rate => real32data(inColumn)
  
  ok = .false.
  
  do i = 0, nFrames-1
     if (rate(i) .lt. 0) then
        ok = .true. 
        write(*,*) i, nFrames
        EXIT
     endif
  enddo
  
  if (ok) then
     
     call error("neg values","Negative value found in column RATE3")
     
  endif
  
  call release(inColumn)  

  inColumn = column(inTable, "RATE4", Read)
  rate => real32data(inColumn)
  
  ok = .false.
  
  do i = 0, nFrames-1
     if (rate(i) .lt. 0) then
        ok = .true. 
        write(*,*) i, nFrames
        EXIT
     endif
  enddo
  
  if (ok) then
     
     call error("neg values","Negative value found in column RATE4")
     
  endif
  
  call release(inColumn)  

  inColumn = column(inTable, "RATE5", Read)
  rate => real32data(inColumn)
  
  ok = .false.
  
  do i = 0, nFrames-1
     if (rate(i) .lt. 0) then
        ok = .true. 
        write(*,*) i, nFrames
        EXIT
     endif
  enddo
  
  if (ok) then
     
     call error("neg values","Negative value found in column RATE5")
     
  endif
  
  call release(inColumn)  

  inColumn = column(inTable, "RATE6", Read)
  rate => real32data(inColumn)
  
  ok = .false.
  
  do i = 0, nFrames-1
     if (rate(i) .lt. 0) then
        ok = .true. 
        write(*,*) i, nFrames
        EXIT
     endif
  enddo
  
  if (ok) then
     
     call error("neg values","Negative value found in column RATE6")
     
  endif
  
  call release(inColumn)  

  inColumn = column(inTable, "RATE7", Read)
  rate => real32data(inColumn)
  
  ok = .false.
  
  do i = 0, nFrames-1
     if (rate(i) .lt. 0) then
        ok = .true. 
        write(*,*) i, nFrames
        EXIT
     endif
  enddo
  
  if (ok) then
     
     call error("neg values","Negative value found in column RATE7")
     
  endif
  
  call release(inColumn)  

  inColumn = column(inTable, "RATE8", Read)
  rate => real32data(inColumn)
  
  ok = .false.
  
  do i = 0, nFrames-1
     if (rate(i) .lt. 0) then
        ok = .true. 
        write(*,*) i, nFrames
        EXIT
     endif
  enddo
  
  if (ok) then
     
     call error("neg values","Negative value found in column RATE8")
     
  endif
  
  call release(inColumn)  

  inColumn = column(inTable, "RATE9", Read)
  rate => real32data(inColumn)
  
  ok = .false.
  
  do i = 0, nFrames-1
     if (rate(i) .lt. 0) then
        ok = .true. 
        write(*,*) i, nFrames
        EXIT
     endif
  enddo
  
  if (ok) then
     
     call error("neg values","Negative value found in column RATE9")
     
  endif
  
  call release(inColumn)  

  inColumn = column(inTable, "RATE10", Read)
  rate => real32data(inColumn)
  
  ok = .false.
  
  do i = 0, nFrames-1
     if (rate(i) .lt. 0) then
        ok = .true. 
        write(*,*) i, nFrames
        EXIT
     endif
  enddo
  
  if (ok) then
     
     call error("neg values","Negative value found in column RATE10")
     
  endif
  
  call release(inColumn)  

end 

